//Includes:
#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include "include/morecolors.inc"

//Terminate:
#pragma semicolon		1

new Handle:EQMode = INVALID_HANDLE;
static String:PlayerModel[33][255];

ConVar g_cvRebelSounds;
ConVar g_cvCombineSounds;

//Initation:
public OnPluginStart()
{
	EQMode = CreateConVar("sv_eqmode", "0", "Turns super soldier on and off. 0 = off, 1 = on");
	RegConsoleCmd("sm_eq", CommandSetEQ, "Turns super soldier on and off");
	PrecacheModel("models/combine_super_soldier.mdl", true);
	g_cvRebelSounds = CreateConVar("sm_rebel_sounds", "0", "What footstep sound should rebels use?");
	g_cvCombineSounds = CreateConVar("sm_combine_sounds", "2", "What footstep sound should combine use?");
	g_cvRebelSounds.AddChangeHook(OnRebelSoundChanged);
	g_cvCombineSounds.AddChangeHook(OnCombineSoundChanged);
	HookEvent("player_spawn", EventSpawn, EventHookMode_Pre);
}

//Map Start:
public OnMapStart() {
	ServerCommand("sv_eqmode 0");
}

//In-Game:
public OnClientPutInServer(Client) {
	CreateTimer(0.1, ChangeModel, Client);
}


public Action: ChangeModel(Handle: Timer, any: Client) {
	KillTimer(Timer); 
	decl String: Buffer[64];
	if(IsClientConnected(Client) && IsClientInGame(Client)) {
    GetClientModel(Client, Buffer, 64);
    FaceModel(Client);
  }
}


public FaceModel(Client) {
	decl String: Buffer[64];
	GetClientModel(Client, Buffer, 64);
	new plyteam = GetClientTeam(Client);
	if(GetConVarInt(EQMode) == 1)
	{	
		SetEntityModel(Client, "models/combine_super_soldier.mdl");
		PlayerModel[Client] = "models/combine_super_soldier.mdl";
		SetEntProp(Client, Prop_Send, "m_iPlayerSoundType", g_cvRebelSounds.IntValue);
		if(GetConVarInt(FindConVar("mp_teamplay")) == 1)
		{
			if(plyteam != 3)
			{
				SetEntityRenderMode(Client, RENDER_TRANSCOLOR);
				SetEntityRenderColor(Client, 39, 111, 255, 255);
			} else if(plyteam != 2)
			{
				SetEntityRenderMode(Client, RENDER_TRANSCOLOR);
				SetEntityRenderColor(Client, 0, 255, 0, 255);
			}
		} else if(GetConVarInt(FindConVar("mp_teamplay")) == 0)
		{
			SetEntityRenderMode(Client, RENDER_TRANSCOLOR);
			SetEntityRenderColor(Client, 0, 255, 0, 255);
		}
	} else if(GetConVarInt(EQMode) == 0)
	{
		SetEntityModel(Client, "models/humans/group03/female_07.mdl");
		PlayerModel[Client] = "models/humans/group03/female_07.mdl";
	}
	if(!StrEqual(PlayerModel[Client], Buffer, false)) SetEntityModel(Client, PlayerModel[Client]);
	
	CreateTimer(1.2, ChangeModel, Client);
}

//Spawn:
public EventSpawn(Handle: Event, const String: Name[], bool: Broadcast) {
	decl Client;
	Client = GetClientOfUserId(GetEventInt(Event, "userid"));
	new plyteam = GetClientTeam(Client);
	if(GetConVarInt(EQMode) == 1)
	{	
		if(IsClientConnected(Client) && IsClientInGame(Client) && IsPlayerAlive(Client)) {
			SetEntityModel(Client, "models/combine_super_soldier.mdl");
			PlayerModel[Client] = "models/combine_super_soldier.mdl";
			SetEntProp(Client, Prop_Send, "m_iPlayerSoundType", g_cvRebelSounds.IntValue);
			if(GetConVarInt(FindConVar("mp_teamplay")) == 1)
			{
				if(plyteam != 3)
				{
					SetEntityRenderMode(Client, RENDER_TRANSCOLOR);
					SetEntityRenderColor(Client, 39, 111, 255, 255);
				} else if(plyteam != 2)
				{
					SetEntityRenderMode(Client, RENDER_TRANSCOLOR);
					SetEntityRenderColor(Client, 0, 255, 0, 255);
				}
			} else if(GetConVarInt(FindConVar("mp_teamplay")) == 0)
			{
				SetEntityRenderMode(Client, RENDER_TRANSCOLOR);
				SetEntityRenderColor(Client, 0, 255, 0, 255);
			}
		}
	} else if(GetConVarInt(EQMode) == 0){
		if(IsClientConnected(Client) && IsClientInGame(Client) && IsPlayerAlive(Client)) {
			SetEntityRenderMode(Client, RENDER_TRANSCOLOR);
			SetEntityRenderColor(Client, 255, 255, 255, 255);
			if(GetConVarInt(FindConVar("mp_teamplay")) == 1)
			{
				if(plyteam != 3)
				{
					SetEntityModel(Client, "models/combine_super_soldier.mdl");
					PlayerModel[Client] = "models/combine_super_soldier.mdl";
					SetEntProp(Client, Prop_Send, "m_iPlayerSoundType", g_cvCombineSounds.IntValue);
				} else if(plyteam != 2)
				{
					SetEntityModel(Client, "models/humans/group03/female_07.mdl");
					PlayerModel[Client] = "models/humans/group03/female_07.mdl";
					SetEntProp(Client, Prop_Send, "m_iPlayerSoundType", g_cvRebelSounds.IntValue);
				}
			} else if(GetConVarInt(FindConVar("mp_teamplay")) == 0)
			{
				SetEntityModel(Client, "models/humans/group03/female_07.mdl");
				PlayerModel[Client] = "models/humans/group03/female_07.mdl";
				SetEntProp(Client, Prop_Send, "m_iPlayerSoundType", g_cvRebelSounds.IntValue);
			}	
		}
	}
	GivePlayerItem(Client, "weapon_crowbar");
}


public Action: CommandSetEQ(Client, Args) {

  decl MaxPlayers2;
  MaxPlayers2 = GetMaxClients();
  if(GetConVarInt(EQMode) == 1)
  {	
    CPrintToChatAll("{red}|INFO|{default} EQ {red}Disabled.");
	ServerCommand("sv_eqmode 0");
	for (new X = 1; X <= MaxPlayers2; X++) {
		if(IsClientConnected(X) && IsClientInGame(X) && IsPlayerAlive(X)) {
			if(GetConVarInt(FindConVar("mp_teamplay")) == 1)
			{
				new plyteam = GetClientTeam(X);
				if(plyteam != 3)
				{
					SetEntityModel(X, "models/combine_super_soldier.mdl");
					PlayerModel[X] = "models/combine_super_soldier.mdl";
					SetEntityRenderMode(X, RENDER_TRANSCOLOR);
					SetEntityRenderColor(X, 255, 255, 255, 255);
					SetEntProp(X, Prop_Send, "m_iPlayerSoundType", g_cvCombineSounds.IntValue);
				} else if(plyteam != 2)
				{
					SetEntityModel(X, "models/humans/group03/female_07.mdl");
					PlayerModel[X] = "models/humans/group03/female_07.mdl";
					SetEntityRenderMode(X, RENDER_TRANSCOLOR);
					SetEntityRenderColor(X, 255, 255, 255, 255);
					SetEntProp(X, Prop_Send, "m_iPlayerSoundType", g_cvRebelSounds.IntValue);
				}
			}
			else 
			{
				SetEntityModel(X, "models/humans/group03/female_07.mdl");
				PlayerModel[X] = "models/humans/group03/female_07.mdl";
				SetEntityRenderMode(Client, RENDER_TRANSCOLOR);
				SetEntityRenderColor(Client, 255, 255, 255, 255);
				SetEntProp(X, Prop_Send, "m_iPlayerSoundType", g_cvRebelSounds.IntValue);
			}
		}
	}
  }	else if(GetConVarInt(EQMode) == 0){
	CPrintToChatAll("{red}|INFO|{default} EQ {green}Enabled.");
	ServerCommand("sv_eqmode 1");
	for (new X = 1; X <= MaxPlayers2; X++) {
		if(IsClientConnected(X) && IsClientInGame(X) && IsPlayerAlive(X)) {
			SetEntityModel(X, "models/combine_super_soldier.mdl");
			PlayerModel[X] = "models/combine_super_soldier.mdl";
			SetEntProp(X, Prop_Send, "m_iPlayerSoundType", g_cvCombineSounds.IntValue);
			if(GetConVarInt(FindConVar("mp_teamplay")) == 1)
			{
				new plyteam = GetClientTeam(X);
				if(plyteam != 3)
				{
					SetEntityRenderMode(X, RENDER_TRANSCOLOR);
					SetEntityRenderColor(X, 39, 111, 255, 255);
				} else if(plyteam != 2)
				{
					SetEntityRenderMode(X, RENDER_TRANSCOLOR);
					SetEntityRenderColor(X, 0, 255, 0, 255);
				}
			} else if(GetConVarInt(FindConVar("mp_teamplay")) == 0)
			{
				SetEntityRenderMode(X, RENDER_TRANSCOLOR);
				SetEntityRenderColor(X, 0, 255, 0, 255);
			}
		}
	}
	
  }	

}


public void OnRebelSoundChanged(ConVar convar, const char[] oldValue, const char[] newValue)
{
	for(int i = 1; i <= MaxClients; i++)
	{
		if(IsClientConnected(i) && IsClientInGame(i) && !IsClientObserver(i) && GetClientTeam(i) == 3)
		{
			SetEntProp(i, Prop_Send, "m_iPlayerSoundType", StringToInt(newValue));
		}
	}
}

public void OnCombineSoundChanged(ConVar convar, const char[] oldValue, const char[] newValue)
{
	for(int i = 1; i <= MaxClients; i++)
	{
		if(IsClientConnected(i) && IsClientInGame(i) && !IsClientObserver(i) && GetClientTeam(i) == 2)
		{
			SetEntProp(i, Prop_Send, "m_iPlayerSoundType", StringToInt(newValue));
		}
	}
}